#!/usr/bin/perl -w
use File::Find;
use HTML::Entities;

#########################################################################
# makewordlist.pl - A wordlistgenerator
# Copyright (C) 2001  Andreas Gohr <a.gohr@web.de>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

#########################################################################
# Whats this?
#
# This Script generates a wordlist from all the text it finds in Text-,
# HTML- and PHP-Files below the given startingdirectory.
# 
# When you want to test the passwordsecurity of your system you possibly
# use a passwordcracker like 'crack' or 'john the ripper'. For these
# tools you need a wordlist with words that will be used to test the
# userlogins. Most users use passwords that have something to do with
# their real live (tm). With this tool you can get everything they
# telling on their homepages into a wordlist.
#
# Please do nothing with that script to anybody that you don't want to be
# done to you, okay?
#

#########################################################################
# Please change to your needs:

#Put the startdirectory in here:
$start_dir="/var/www/";
#$start_dir="/home/";

$verbose=1; #0 does nothing
            #1 prints a dot for every parsed file and a + for errors to STDERR
            #2 prints the name of every parsed file or Error to STDERR

#########################################################################
# No changes should be needed below:

find( \&slurpit, $start_dir ); # see below for subroutine

#sorting and unduping:
undef %saw;
@saw{@wordlist} = ();
@sortlist = sort keys %saw;
#Yeah found that one on the net :-)

foreach $line (@sortlist) {
  print "$line\n";
}


sub slurpit {
  if ( (! -d $File::Find::name) && ( $File::Find::name =~ /.*\.(s?html?|php(3|4)?|txt)$/ ) ) {
    if (!open (FILE, "$File::Find::name")) {
      print STDERR "+" if $verbose==1;
      print STDERR "Error reading $File::Find::name \n" if $verbose==2;
      return;
    }
    
    my @file = <FILE>;
    my $file_string = join (' ',@file);     #I want the whole file as string

    #Some regexp-magic:
    $file_string=~tr/\n\r\t\f/    /;        #replace special chars with spaces
    $file_string=~s/<[^>]+>//g;             #remove html-tags -wow found that regexp in the net :-)
    $file_string=~tr/[A-Z]/[a-z]/;          #change to lowercase
    decode_entities($file_string);          #As the name says
    $file_string=~s/[^a-z_0-9 ]/ /g;    #remove nonletters (I know not the best for wordlists)
    $file_string=~s/  */ /g;                #remove multiple spaces
 
    my @words = split(/ /,$file_string);    #Now I want an array:-)
    push (@wordlist,@words);
      
    close FILE;

    print STDERR "." if $verbose==1;
    print STDERR "$File::Find::name\n" if $verbose==2;
  }
}
